<template>
  <div
    v-if="playableGameForModule5.length > 0"
    class="container mx-auto module-four"
  >
    <div class="--text2 text-2xl font-bold lobby-title">
      {{ $t("sports_betting") }}
    </div>
    <div class="overflow-x-hidden px-4 lg:px-0 pt-4 module-four-item">
      <swiper
        :slides-per-view="cardDisplayAmount"
        :loop="true"
        :initial-slide="0"
        :space-between="spaceBetween"
        effect="coverflow"
        :coverflow-effect="swiperEffect"
        :slide-to-clicked-slide="true"
        :centered-slides="true"
        :allow-touch-move="allowTouchMove"
        class="pb-0 sm:!pb-10"
        @before-transition-start="onBeforeSlideChangeStart"
      >
        <swiper-slide
          v-for="game in playableGameForModule5"
          :key="game.GameId"
          class="relative main-class"
          :class="{ hoverable }"
        >
          <div
            class="swipe-card relative w-full rounded-2xl overflow-hidden cursor-pointer">
            <div style="background-color: black; z-index: 1" class="absolute w-full h-full active-class"></div>
            <!-- <div style="background-color: black; z-index: -2000 !important" class="absolute w-full h-full"></div> -->
            <div class="player relative rounded-2xl overflow-hidden background-img" :style="`z-index: -100 !important; background: url(${cardBackground}) no-repeat; background-size:cover`">
              <img :src="game.StarImagePath"
                class="football-player relative left-1/2 translate-x-[-50%] transition-[top] object-contain delay-50 duration-500 ease-in-out hero-width"
              />
              <div
                class="absolute left-0 bottom-0 rectangle ol-bg-light sport-bg opacity-90 w-full h-[180px]"
              ></div>
              <div
                class="absolute left-0 bottom-0 rectangle rotated-rectangle ol-bg-light sport-bg-01 opacity-60 w-full h-[180px]"
              ></div>
              <div
                v-if="providerCount[game.GameProviderName] > 1"
                class="provider-name bottom-0 absolute items-center justify-center left-1/2 translate-x-[-50%] transition-[bottom,transform] delay-50 duration-500 ease-in-out"
              >
                <div
                  class="game-icon mb-1"
                  :class="
                    providerCount[game.GameProviderName] > 1
                      ? ''
                      : 'game-margin'
                  "
                >
                  <img
                    :src="game.ProviderLogoCenterPath"
                    class="object-contain w-full h-full"
                  />
                </div>
                <span
                  v-if="providerCount[game.GameProviderName] > 1"
                  class="text-xs pb-3.5 flex justify-center display-name whitespace-nowrap"
                >
                  {{ game.GameName }}
                </span>
              </div>
              <div
                v-else
                class="provider-name-01 game-icon logo bottom-0 absolute items-center justify-center left-1/2 translate-x-[-50%] transition-[bottom,transform] delay-50 duration-500 ease-in-out"
              >
                <div
                  class="game-icon"
                  :class="
                    providerCount[game.GameProviderName] > 1
                      ? ''
                      : 'game-margin'
                  "
                >
                  <img
                    :src="game.ProviderLogoCenterPath"
                    class="object-contain w-full h-full"
                  />
                </div>
              </div>
              <el-button
                class="button-play absolute left-1/2 translate-x-[-50%] w-[142px] !h-[28px] truncate !text-xs font-bold"
                type="success"
                @click="
                  () =>
                    onClickPlayGame(
                      Number(game?.GameId),
                      authenticated,
                      'sports',
                      EnumEntranceLocation.GameLobby
                    )
                "
              >
                {{ $t("play_now") }}
              </el-button>
            </div>
          </div>
        </swiper-slide>
        <div
          class="swiper-pagination absolute left-1/2 translate-x-[-50%] bottom-1 flex items-center gap-x-8 w-[188px] h-3"
        >
          <span
            v-for="index in visibleSlidelength"
            :key="`slider-bullet-${index}`"
            class="swiper-pagination-bullet"
            :class="{
              'swiper-pagination-bullet-active':
                activePaginationIndex === index,
            }"
          ></span>
        </div>
      </swiper>
    </div>
  </div>
</template>

<script setup lang="ts">
import "swiper/css";
import "swiper/css/pagination";
import "swiper/css/navigation";
import { ref } from "vue";
import { ILobbySettingsText } from "~~/models/customizeTheme";
import textHelper from "~~/utils/formatHelpers/textFormatHelper";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import useSportModule from "~~/composables/lobby/useSportModule";
import commonHelper from "@/utils/commonHelper";

const props = withDefaults(
  defineProps<{
    data: ILobbySettingsText;
    spaceBetween?: number;
    hoverable?: boolean;
    allowTouchMove?: boolean;
  }>(),
  {
    spaceBetween: 16,
    hoverable: true,
  }
);
const cardBackground = commonHelper.getAssetImage(
  `assets/theme/common/LobbySettings/SportsModule/Sports_Module_05/bg_card.png`
);
const visibleSlidelength = ref(5);
const activePaginationIndex = ref(1);
const { onClickPlayGame } = commonHelper;
const { playableGameForModule5, authenticated } = useSportModule(props.data);
const providerCount = computed(() => textHelper.checkMultiple(playableGameForModule5.value));
const cardDisplayAmount = ref(5);
const handleWindowSize = () => {
  if (window.innerWidth < 1024) {
    cardDisplayAmount.value = 3;
  } else if (window.innerWidth >= 1024) {
    cardDisplayAmount.value = 5;
  }
};
window.addEventListener("resize", handleWindowSize);
handleWindowSize();
const onBeforeSlideChangeStart = (swiper: any) => {
  if (!useIsDesktop()) return;
  const realIndex = swiper.realIndex + 1;
  if (realIndex <= 5 && realIndex >= 1) activePaginationIndex.value = realIndex;
  else if (realIndex % 5 === 0) activePaginationIndex.value = 5;
  else activePaginationIndex.value = realIndex % 5;
};
</script>

<style scoped lang="scss">
.main-class {
  &:not(.swiper-slide-active) {
    .football-player {
      @apply top-3;
    }
    .active-class {
      @apply opacity-50;
    }
  }
  &.hoverable:hover:not(.swiper-slide-active) {
    .provider-name,
    .provider-name-01 {
      @apply scale-105;
    }
    .football-player {
      @apply top-[-1px];
    }
  }
  &.no-slide,
  &.swiper-slide-active {
    @apply opacity-100;
    &.hoverable:hover {
      .provider-name {
        @apply bottom-10;
      }
      .provider-name-01 {
        @apply bottom-14;
      }
      .button-play {
        @apply bottom-3.5;
        padding: 0 16px !important;
      }
      .football-player {
        @apply top-[-1px];
      }
    }
    .football-player {
      @apply top-4;
    }
    .active-class {
      @apply opacity-0;
      display: none;
    }
  }
}
.module-four {
  .background-img {
    background-size: cover;
    background-repeat: no-repeat;
    background-position: center;
  }

  .rectangle {
    clip-path: polygon(0 60%, 100% 0, 100% 100%, 0 100%);
  }

  .rotated-rectangle {
    clip-path: polygon(0 0, 100% 60%, 100% 100%, 0 100%);
  }
  .display-name {
    color: var(--text5);
  }
  .button-play {
    @apply bottom-[-40px];
    background-color: var(--primary);
    border-color: transparent;
    color: var(--textBtn);
    // need to override transition of el-button
    transition: bottom 300ms ease-in-out 100ms !important;
  }

  .swiper-pagination {
    transform: translate(-50%, -50%) !important;
    .swiper-pagination-bullet {
      @apply w-3 h-3 text-[#9B9B9B99] opacity-60;

      &.swiper-pagination-bullet-active {
        background: var(--primary);
      }
    }
  }
  .swiper-slide-active {
    .swipe-card {
      position: absolute;
      left: 50%;
      top: 50%;
      transform: translate(-50%, -50%);
      width: 256px;
      aspect-ratio: 256/336;
      .player {
        height: 100%;
      }
    }
    height: 336px;
    .hero-width {
      width: 256px;
      height: 256px;
    }
    .game-icon {
      width: 170px;
      aspect-ratio: 170/68;
    }
    .logo {
      bottom: 14.22px;
    }
  }
  .swiper-slide-next,
  .swiper-slide-prev {
    .swipe-card {
      width: 230px;
      aspect-ratio: 230/302;
    }
    height: unset;
    .player {
      height: 100%;
    }
    .hero-width {
      width: 230px;
      height: 230px;
    }
    .game-icon {
      width: 152.73px;
      height: 61px;
    }
    .logo {
      bottom: 14.45px;
    }
  }
  .swiper-slide-prev {
    right: 16px;
    .swipe-card {
      position: absolute;
      top: 50%;
      left: calc(50%);
      transform: translate(-50%, -50%);
    }
  }
  .swiper-slide-next {
    left: 16px;
    .swipe-card {
      position: absolute;
      top: 50%;
      left: calc(50%);
      transform: translate(-50%, -50%);
    }
  }
  .swiper-slide:not(.swiper-slide-active):not(.swiper-slide-next):not(
      .swiper-slide-prev
    ) {
    height: unset;
    right: 16px;
    .swipe-card {
      position: absolute;
      top: 50%;
      left: calc(50% + 8px);
      transform: translate(-50%, -50%);
      width: 210px;
      aspect-ratio: 210/276;
      .player {
        height: 100%;
      }
    }
    .player {
      height: 100%;
    }
    .hero-width {
      width: 210px;
      height: 210px;
    }
    .game-icon {
      width: 139.45px;
      height: 55.78px;
    }
    .logo {
      bottom: 12.93px;
    }
  }
  .swiper-slide-next
    + .swiper-slide:not(.swiper-slide-active):not(.swiper-slide-next):not(
      .swiper-slide-prev
    ) {
    left: 16px;
    .swipe-card {
      position: absolute;
      top: 50%;
      left: calc(50% - 8px);
      transform: translate(-50%, -50%);
      width: 210px;
      aspect-ratio: 210/276;
      .player {
        height: 100%;
      }
    }
  }
  .swiper {
    width: 100%;
  }
  .sport-bg,
  .sport-bg-01 {
    --bg-opacity: 0.05;
    --bg-base-color: var(--background5);
  }
  @media (max-width: 1280px) {
    .swiper-slide-active {
      height: unset;
      aspect-ratio: 227/336;
      .swipe-card {
        transform: translate(-50%, -50%);
        left: calc(50% - 1px);
        width: 110%;
        .game-icon {
          width: 110px;
          height: 44px;
        }
      }
    }
    .swiper-slide-next
      + .swiper-slide:not(.swiper-slide-active):not(.swiper-slide-next):not(
        .swiper-slide-prev
      ) {
      left: 0;
      .swipe-card {
        left: calc(50% + 8px);
        width: 90%;
      }
    }
    .swiper-slide:not(.swiper-slide-active):not(.swiper-slide-next):not(
        .swiper-slide-prev
      ) {
      right: 0;
      .swipe-card {
        position: absolute;
        top: 50%;
        left: calc(50% - 8px);
        transform: translate(-50%, -50%);
        width: 90%;
        .game-icon {
          width: 110px;
          height: 44px;
        }
      }
    }
    .swiper-slide-prev,
    .swiper-slide-next {
      .swipe-card {
        .game-icon {
          width: 110px;
          height: 44px;
        }
      }
    }
    .swiper-slide-prev {
      .swipe-card {
        position: absolute;
        top: 50%;
        left: calc(50% + 2px);
        transform: translate(-50%, -50%);
        width: 100%;
      }
    }
    .swiper-slide-next {
      .swipe-card {
        position: absolute;
        top: 50%;
        left: calc(50% - 2px);
        transform: translate(-50%, -50%);
        width: 100%;
      }
    }
  }
}
</style>
